<template>
  <single-pane capt="Конфигуратор услуг">
    <ob-table
      v-model="searchValue"
      ref="dataGrid"
      :dataGridRefName="dataGridRefName"
      :add-button="true"
      :columns="$options.columns"
      :remote-opt="getObTableData"
      @add="onAdd"
      @select="onSelectionItem"
    />
    <ob-modal
      ref="viewItem"
      custom-class="modal-medium"
      :title="newStatus ? 'Новая услуга' : 'Услуга'"
      :data-grid="$refs.dataGrid"
      :is-show-pagination="!newStatus"
    >
      <view-service
        :service-measurement-units="serviceMeasurementUnits"
        :service-types="serviceTypes"
        :selected-data="selectedData"
        :data-source="selectedData"
        :disabledForm="disabledForm"
        @delete="onDelete"
        @save="onSave"
      />
    </ob-modal>
  </single-pane>
</template>

<script>
import api                   from '@/api';
import cloneDeep             from 'clone-deep';
import { SERVICE_GEOGRAPHY } from '@/resources/enum';
import paging                from '@/mixins/paging';
import itemMixin             from '@/mixins/edit-item';
import SinglePane            from 'common-components/src/obComponents/obSinglePanels';
import ObTable               from 'common-components/src/obComponents/obTable';
import ViewService           from './modal/viewService';
import ObModal               from 'common-components/src/obComponents/obModal';

export default {
  name: 'Services',
  components: {
    ObModal,
    ViewService,
    ObTable,
    SinglePane
  },
  mixins: [paging, itemMixin],
  columns: [
    {
      title: 'Тип услуги',
      field: 'denomination',
      calculateCellValue(data) {
        return data.services && data.services.length > 0
          ? data.services[0].service_type.denomination
          : '';
      }
    },
    {
      title: 'Тип ресурса',
      field: 'activity_name',
      calculateCellValue(data) {
        let resource_species = data.services
          ? data.services.reduce((prev, service) => {
              return prev + ' ' + service.resource_species.name + ',';
            }, '')
          : '';
        return resource_species.slice(0, resource_species.length - 1);
      }
    },
    {
      title: 'География',
      field: 'service_geography',
      calculateCellValue(data) {
        return data.services && data.services.length > 0
          ? SERVICE_GEOGRAPHY[data.services[0].service_type.service_geography]
          : '';
      }
    },
    {
      title: 'Характеристика ресурса',
      field: 'services',
      allowSorting: false,
      calculateCellValue(data) {
        let resource_pattern = data.services
          ? data.services.reduce((prev, service) => {
              return (
                prev +
                ' ' +
                service.resource_pattern.mask.value
                  .replace('XX', service.resource_pattern.parameters.XX)
                  .replace('YY', service.resource_pattern.parameters.YY)
                  .replace('ZZ', service.resource_pattern.parameters.ZZ) +
                ','
              );
            }, '')
          : '';
        return resource_pattern.slice(0, resource_pattern.length - 1);
      }
    },
    {
      title: 'Возможные ед. измерения',
      field: 'service_units',
      allowSorting: false,
      calculateCellValue(data) {
        let units = data.service_units
          ? data.service_units.reduce((prev, current) => {
              return prev + ' ' + current.name + ',';
            }, '')
          : '';
        return units.slice(0, units.length - 1);
      }
    },
    {
      title: 'Статус',
      width: 110,
      field: 'status_model',
      calculateCellValue(data) {
        return data.deleted_at ? 'Неактивно' : 'Активно';
      }
    }
  ],
  mounted() {
    // TODO убрать констатнку 100
    api.services
      .getServiceTypes(false, 0, 100)
      .then(({ data }) => {
        this.serviceTypes = data.content;
      })
      .catch(e => {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
      });
    // TODO убрать констатнку 100
    api.services
      .getServiceMeasurementUnits(0, 100)
      .then(({ data }) => {
        this.serviceMeasurementUnits = data.content;
      })
      .catch(e => {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
      });
  },
  computed: {
    disabledForm() {
      return !this.newStatus;
    },
    activeServiceType() {
      let _type = this.serviceTypes.find(type => {
        return type.uuid === this.selectedData.serviceTypeUuid;
      });
      return _type ? _type : {};
    }
  },
  data() {
    return {
      newStatus: false,
      selectedData: {},
      serviceTypes: [],
      serviceMeasurementUnits: [],
      newData: {
        newStatus: true,
        serviceTypeUuid: '',
        serviceGeography: '',
        resourceSpecies: [],
        resourceSubTypeUuid: [],
        serviceUnits: []
      },
      dataGridRefName: 'Services',
      api: {
        source: 'services',
        method: 'getServices'
      }
    };
  },
  methods: {
    onSave() {
      this.$refs.viewItem.close();
      this.$refs.dataGrid.$refs[this.dataGridRefName].instance.refresh(true);
      this.newStatus = false;
    },
    onAdd() {
      this.newStatus = true;
      this.selectedData = cloneDeep(this.newData);
      this.$refs.viewItem.open();
    },
    async onSelectionItem(data) {
      try {
        this.newStatus = false;
        let _data = await api.services.getService(data.uuid);
        let resourceSpecies = _data.data.services.map(service => {
          return {
            species: service.resource_species,
            resource_pattern: service.resource_pattern,
            subTypes: [service.resource_sub_type],
            subTypeUuid: service.resource_sub_type.uuid,
            patternUuid: service.resource_pattern.uuid
          };
        });
        this.selectedData = {
          newStatus: false,
          uuid: _data.data.uuid,
          serviceTypeUuid:
            _data.data.services && _data.data.services.length > 0
              ? _data.data.services[0].service_type.uuid
              : '',
          serviceGeography:
            _data.data.services && _data.data.services.length > 0
              ? _data.data.services[0].service_type.service_geography
              : '',
          resourceSubTypeUuid:
            _data.data.services && _data.data.services.length > 0
              ? [_data.data.services[0].resource_sub_type.uuid]
              : [],
          resourceSpecies: [],
          serviceUnits: _data.data.service_units
            ? _data.data.service_units.map(unit => {
                return unit.uuid;
              })
            : [],
          deleted_at: _data.data.deleted_at
        };
        this.$set(this.selectedData, 'resourceSpecies', resourceSpecies);
        this.$refs.viewItem.open();
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
      }
    },
    async onDelete() {
      let notificationId = new Date().getTime() + 'save';
      try {
        this.$notification({
          type: 'system_notification_in_load',
          message: 'Сохранение',
          id: notificationId
        });
        await api.services.deleteService(this.selectedData.uuid);
        this.$refs.dataGrid.$refs[this.dataGridRefName].instance.refresh(true);
        this.$notification({
          type: 'system_notification_success',
          message: 'Сохранено'
        });
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Не сохранено'
        });
      } finally {
        this.$notification({ event: 'close', id: notificationId });
      }
    }
  }
};
</script>
